'use strict';

axios.defaults.xsrfHeaderName = "X-CSRFTOKEN";
axios.defaults.xsrfCookieName = "csrftoken";
axios.defaults.withCredentials = true;

function SuccessMessage(props) {

  if (!props.show) {
    return null
  }

  return (

    <div className="">
      {/* <!-- INFO BAR --> */}
      <div className="">
        <div className="flex flex-col px-6 pb-3">
          <div className="flex flex-row items-center space-x-2">
            <span>
              <svg xmlns="http://www.w3.org/2000/svg" className="h-8 w-8 text-green-600" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                <path strokeLinecap="round" strokeLinejoin="round" strokeWidth="2" d="M9 12l2 2 4-4m6 2a9 9 0 11-18 0 9 9 0 0118 0z" />
              </svg>
            </span>
            <h1 className="text-2xl text-green-600 font-bold">
              Successfully submitted
          </h1>
          </div>

          <p className="text-sm text-gray-600 font-medium">
            You will be recieve SMS on {props.number} when item is available</p>

        </div>
      </div>
    </div>

  )
}

class ContactForm extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      error: '',
      isLoading: false,
      show: false,
      list: [],
      name: '',
      product: '',
      number: '',
    };
    // this.handleToggleClick = this.handleToggleClick.bind(this);
  }


  onSubmit = event => {
    const contact = {
      name: this.state.name,
      number: this.state.number,
      notified: false,
      product: document.getElementById('product-id').getAttribute("data-id")
    };
    this.setState({ isLoading: true });
    axios.post(`http://localhost:8000/api/contact/`, contact)
      .then(list => {
        this.setState({
          isLoading: false,
          list: list.data,
          show: true
        });
        console.log(list.data)

      }).catch((errors) => {
        this.setState({ isLoading: false, errors: 'please enter correct information' })
      });
    event.preventDefault();
  };

  render() {

    return (
      <div>

        <SuccessMessage show={this.state.show} name={this.state.name} number={this.state.number} />
        {!this.state.show && <div>

          <div>
            <form onSubmit={this.onSubmit}>
              <div className="relative z-0 w-full mb-5">

                <input type="text" id="name" onChange={event => this.setState({ name: event.target.value })}
                  name="name"
                  placeholder="Full Name "
                  required
                  className="text-xl font-bold rounded border-2 border-gray-400 text-gray-600 h-14 w-full pl-5 pr-10 bg-white hover:border-gray-400 focus:outline-none appearance-none"
                />
              </div>

              <div className="relative z-0 w-full mb-5">

                <input type="tel" id="phone_number" onChange={event => this.setState({ number: event.target.value })}
                  name="phone_number"
                  required
                  placeholder="Phone Number"
                  className="text-xl font-bold rounded border-2 border-gray-400 text-gray-600 h-14 w-full pl-5 pr-10 bg-white hover:border-gray-400 focus:outline-none appearance-none"
                />

              </div>

              <div className="flex flex-col items-center">
                <button id="button" type="submit"
                  className="w-90 px-6 py-1 mt-3 text-lg text-gray-600 transition-all duration-150 ease-linear  shadow-sm rounded-full outline-none bg-gray-200 hover:bg-gray-300 hover:shadow-lg focus:outline-none tracking-wide">
                  {this.state.isLoading ? "submitting..." : "Submit"}
                </button>
              </div>
            </form>
          </div>
        </div >
        }
      </div>
    )
  }
}

// contact modal
function App() {

  return (
    <div>
      <ContactForm />
    </div>
  );
}

ReactDOM.render(
  <App />,
  document.getElementById('contact')
);
